#!/bin/bash

CONTROLLER_USER="electrosense"
CONTROLLER_HOST="controller.electrosense.org"
CONTROLLER_PORT_SSH="2227"
CONTROLLER_PORT_MYSQL="3308"
INTERFACE="eth0"

while true
do
  PROC=`pgrep -f '0:localhost:22'`

  # if there is no session running
  if [ ! "$PROC" ]; then
    # SSH
    port=(`ssh -o StrictHostKeyChecking=no -o TCPKeepAlive=yes -o ServerAliveInterval=60 -o ServerAliveCountMax=3 -i /etc/electrosense/certs/id_sensor -fNT -R 0:localhost:22 -p $CONTROLLER_PORT_SSH $CONTROLLER_USER@$CONTROLLER_HOST 2>&1 | grep -m 1 -o "Allocated port [0-9]\+" | grep -o "[0-9]\+"`)
    timestamp=$(date)
    if [ $? -eq 0 ]; then
      printf "$timestamp  Reverse SSH tunnel opened successfully on remote port $port.\n"
    else
      printf "$timestamp  Failed to open reverse SSH tunnel_ RC $?.\n"
    fi

    #MySQL
    mac_hex=$(ip link show $INTERFACE | awk '/ether/ {print $2}')
    mac_dec=${mac_hex//:}
    mac_dec=$((16#$mac_dec))
    SSL_DIR="/etc/electrosense/certs"
    SSL_CA="$SSL_DIR/CA-Cert.pem"
    SSL_CERT="$SSL_DIR/Sensor-MySQL-Cert.pem"
    SSL_KEY="$SSL_DIR/Sensor-MySQL-SK.pem"
    SQL_REQ="REPLACE INTO local_connections(MAC,Port) VALUES($mac_dec,$port)"
    SQL_SSL="--ssl-ca=$SSL_CA --ssl-cert=$SSL_CERT --ssl-key=$SSL_KEY"
    sqlres=(`mysql --host="$CONTROLLER_HOST" --port=$CONTROLLER_PORT_MYSQL --user=sensor --password=es-sensor-pass --database=electrosense $SQL_SSL --execute="$SQL_REQ"`)
    if [ -z $sqlres ]; then
      printf "$timestamp  MySQL update succeeded.\n"
    else
      pkill -f '0:localhost:22'
      printf "$timestamp MySQL update failed. Reverse SSH tunnel closed.\n"
    fi
  fi
  sleep 10
done
